# DescribeVirtualEdgeDatacenters

## 1. API Description

This API is used to query data centers supporting virtual edge service.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

<table><thead><tr><th width="189">Parameter Name</th><th width="104.34482758620689">Required</th><th width="114">Type</th><th>Description</th></tr></thead><tbody><tr><td>primaryDcId</td><td>No</td><td>String</td><td>Primary data center ID.<br>When accessing virtual edge with high availability enabled, this parameter can be used to filter for available backup data centers.</td></tr></tbody></table>

## 3. Output Parameters

<table><thead><tr><th width="161.71484375">Parameter Name</th><th width="220.79260696992685">Type</th><th>Description</th></tr></thead><tbody><tr><td>requestId</td><td>String</td><td>The unique request ID, which is returned for each request. RequestId is required for locating a problem.</td></tr><tr><td>dcSet</td><td>Array of <a href="../../datastructure#datacenterinfo">DatacenterInfo</a></td><td>The list of data centers available.</td></tr></tbody></table>

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query data centers supporting virtual edge service.**

```json
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeVirtualEdgeDatacenters
<Common Request Params>

Request: 
{
}

Response: 
{
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "response": {
        "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
        "dcSet": [
            {
                "dc": {
                    "dcId": "SIN1",
                    "dcName": "AP-Singapore1",
                    "cityName": "Singapore",
                    "areaName": "Asia Pacific",
                    "countryName": "Singapore",
                    "lat": 50.09708300,
                    "lng": 8.64414900,
                    "dcAddress": "20 Ayer Rajah Crescent, Ayer Rajah Industrial Park, Singapore 139964"
                },
                "availableBandwidth": 1000
            }
        ]
    }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk) to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

No error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode).​
